Index: trunk/source/processes/hadronic/models/parton_string/management/include/G4VPartonStringModel.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/include/G4VPartonStringModel.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/include/G4VPartonStringModel.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VPartonStringModel.hh,v 1.3 2006/06/29 20:55:27 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4VPartonStringModel_h
Index: trunk/source/processes/hadronic/models/parton_string/management/include/G4VSplitableHadron.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/include/G4VSplitableHadron.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/include/G4VSplitableHadron.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VSplitableHadron.hh,v 1.3 2006/06/29 20:55:29 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4VSplitableHadron.hh,v 1.4 2008/05/19 13:03:20 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
@@ -75,4 +75,7 @@
       void SetCollisionCount(G4int aCount);
 
+      void SetTimeOfCreation(G4double aTime);           // Uzhi 7.05.08
+      G4double GetTimeOfCreation();                     // Uzhi 7.05.08
+
       void SetPosition(const G4ThreeVector &aPosition);
       const G4ThreeVector & GetPosition() const;
@@ -83,7 +86,7 @@
       G4bool IsSplit() { return isSplit;}
 
+      G4int GetSoftCollisionCount();
+  protected:
 
-  protected:
-      G4int GetSoftCollisionCount();
       void Splitting() {isSplit = true;}
       
@@ -99,4 +102,5 @@
       G4LorentzVector the4Momentum;
 
+      G4double TimeOfCreation;    // Uzhi 7.05.08
       G4ThreeVector thePosition;
       G4int theCollisionCount;
@@ -141,4 +145,13 @@
 }
 
+inline void G4VSplitableHadron::SetTimeOfCreation(G4double aTime)  // Uzhi 7.05.08
+{
+        TimeOfCreation=aTime;
+}
+
+inline G4double G4VSplitableHadron::GetTimeOfCreation()           // Uzhi 7.05.08
+{
+        return TimeOfCreation; 
+}
 
 inline void G4VSplitableHadron::SetPosition(const G4ThreeVector &aPosition)
Index: trunk/source/processes/hadronic/models/parton_string/management/include/G4VStringFragmentation.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/include/G4VStringFragmentation.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/include/G4VStringFragmentation.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VStringFragmentation.hh,v 1.3 2006/06/29 20:55:31 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4VStringFragmentation_h
Index: trunk/source/processes/hadronic/models/parton_string/management/include/G4VertexCode.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/include/G4VertexCode.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/include/G4VertexCode.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VertexCode.hh,v 1.3 2006/06/29 20:55:33 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4VertexCode_h
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4EventGenerator.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4EventGenerator.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4EventGenerator.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EventGenerator.cc,v 1.4 2006/06/29 20:55:37 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // G4EventGenerator
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4InteractionContent.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4InteractionContent.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4InteractionContent.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4InteractionContent.cc,v 1.4 2006/06/29 20:55:39 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // ------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4PomeronCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4PomeronCrossSection.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4PomeronCrossSection.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PomeronCrossSection.cc,v 1.6 2006/11/07 12:51:39 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4StringModel.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4StringModel.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4StringModel.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4StringModel.cc,v 1.4 2006/06/29 20:55:45 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // G4StringModel
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4VParticipants.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4VParticipants.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4VParticipants.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VParticipants.cc,v 1.3 2006/06/29 20:55:47 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // ------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4VPartonStringModel.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4VPartonStringModel.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4VPartonStringModel.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VPartonStringModel.cc,v 1.5 2007/01/24 10:29:30 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 //// ------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4VSplitableHadron.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4VSplitableHadron.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4VSplitableHadron.cc	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VSplitableHadron.cc,v 1.4 2006/06/29 20:55:51 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4VSplitableHadron.cc,v 1.5 2008/05/19 13:03:20 vuzhinsk Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 
@@ -42,10 +42,10 @@
 
 G4VSplitableHadron::G4VSplitableHadron()
-      :  theDefinition(NULL), theCollisionCount(0), isSplit(false)
+      :  theDefinition(NULL), TimeOfCreation(0.), theCollisionCount(0), isSplit(false) // Uzhi 8.05.08
 {
 }
 
 G4VSplitableHadron::G4VSplitableHadron(const G4ReactionProduct & aPrimary)
-      :  theCollisionCount(0), isSplit(false)
+      :  TimeOfCreation(0.), theCollisionCount(0), isSplit(false)                     // Uzhi 8.05.08
 {
 	theDefinition=aPrimary.GetDefinition();
@@ -56,27 +56,30 @@
 G4VSplitableHadron::G4VSplitableHadron(const G4Nucleon & aNucleon)
 {
-	theCollisionCount=0;
-  isSplit = false;
-	theDefinition=aNucleon.GetParticleType();
-	the4Momentum=aNucleon.GetMomentum();
-	thePosition=aNucleon.GetPosition();
+        TimeOfCreation   = 0.;   // Uzhi 8.05.08
+	theCollisionCount= 0;
+        isSplit          = false;
+	theDefinition    =aNucleon.GetParticleType();
+	the4Momentum     =aNucleon.GetMomentum();
+	thePosition      =aNucleon.GetPosition();
 }
 
 G4VSplitableHadron::G4VSplitableHadron(const G4VKineticNucleon * aNucleon)
 {
-	theCollisionCount=0;
-  isSplit = false;
-	theDefinition=aNucleon->GetDefinition();
-	the4Momentum=aNucleon->Get4Momentum();
-	thePosition=aNucleon->GetPosition();
+        TimeOfCreation   = 0.;   // Uzhi 8.05.08
+	theCollisionCount= 0;
+        isSplit          = false;
+	theDefinition    =aNucleon->GetDefinition();
+	the4Momentum     =aNucleon->Get4Momentum();
+	thePosition      =aNucleon->GetPosition();
 }
 
 G4VSplitableHadron::G4VSplitableHadron(const G4VSplitableHadron &right)
 {
-	theCollisionCount=0;
-  isSplit = false;
-	theDefinition= right.GetDefinition();
-	the4Momentum= right.Get4Momentum();
-	thePosition=  right.GetPosition();
+        TimeOfCreation   = 0.;   // Uzhi 8.05.08
+	theCollisionCount= 0;
+        isSplit          = false;
+	theDefinition    = right.GetDefinition();
+	the4Momentum     = right.Get4Momentum();
+	thePosition      =  right.GetPosition();
 }
 
Index: trunk/source/processes/hadronic/models/parton_string/management/src/G4VStringFragmentation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/management/src/G4VStringFragmentation.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/management/src/G4VStringFragmentation.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VStringFragmentation.cc,v 1.4 2006/06/29 20:55:53 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // G4VStringFragmentation
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/History
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/History	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/History	(revision 962)
@@ -1,3 +1,3 @@
-$Id: History,v 1.4.2.1 2008/04/23 15:25:01 gcosmo Exp $
+$Id: History,v 1.6 2008/09/19 09:54:23 gunter Exp $
 -------------------------------------------------------------------
 
@@ -16,16 +16,18 @@
      ---------------------------------------------------------------
 
-23 Apr 2008 Gabriele Cosmo (hadr-qgsm-V09-00-00)
+
+15 Sep 2008 G.Folger       (hadr-qgsm-V09-01-01)
 ------------------------------------------------
-- Tag for release 9.1.p02.
+- Fix for bug found on windows in G4QGSParticipants.cc, bug 1018:
+   decrement of iterator fails, improve logic to not decrement.
 
 31 Mar 2008 Dennis Wright (hadr-qgsm-V09-01-00)
 -----------------------------------------------
-- Fix gcc-4.3 compiler warnings at lines 293, 395 of G4QGSMSplittableHadron.cc
+-  fix gcc-4.3 compiler warnings at lines 293, 395 of G4QGSMSplittableHadron.cc
 
 24 Apr 2007 Gunter Folger  (hadr-qgsm-V08-02-02)
 ------------------------------------------------
-- Merge in change done by ftf dev; ie. in G4QGSParticipants, theDiffExcitaton
-  is constructed with default arguments.
+-  merge in change done by ftf dev; ie. in G4QGSParticipants, theDiffExcitaton
+   is constructed with default arguments.
 
 25 Jan 2007 Gunter Folger  (hadr-qgsm-V08-02-01)
@@ -35,8 +37,8 @@
 24 Jan 2007 Gunter Folger  (hadr-qgsm-V08-02-00)
 ------------------------------------------------
-- Correct E-p non-conservation in QGS. In 4QGSMSplitableHadron.cc the smaller
-  of the lightcone momenta Q+/Q- was ignored.
-- G4QGSMSplitableHadron correct divide by 0 in SampleX()
-- Add debugging output to several classes
+-  Correct E-p non-conservation in QGS. In 4QGSMSplitableHadron.cc the smaller
+   of the lightcone momenta Q+/Q- was ignored.
+-  G4QGSMSplitableHadron correct divide by 0 in SampleX()
+-  Add debugging output to several classes
 
 30 Nov 2005 Gabriele Cosmo (hadr-qgsm-V07-01-00)
Index: trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4QGSParticipants.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4QGSParticipants.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/parton_string/qgsm/src/G4QGSParticipants.cc	(revision 962)
@@ -262,5 +262,6 @@
   std::vector<G4InteractionContent*>::iterator i;
   G4LorentzVector str4Mom;
-  for(i = theInteractions.begin(); i != theInteractions.end(); i++)   
+  i = theInteractions.begin();
+  while ( i != theInteractions.end() )   
   {
     G4InteractionContent* anIniteraction = *i;
@@ -304,7 +305,8 @@
       }  
       delete *i;
-      i=theInteractions.erase(i);
-      i--;
-    }
+      i=theInteractions.erase(i);    // i now points to the next interaction
+    } else {    
+      i++;
+    }  
   }
 #ifdef debug_G4QGSPart_PSoftColl
